<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="110px">
      <el-form-item label="公司名称" prop="companyId" >
        <el-select v-model="queryParams.companyId" placeholder="请选择所属公司" clearable filterable size="small">
          <el-option v-for="(option, index) in companyList" :key="index" :value="option.dictValue" :label="option.dictLabel"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="员工" prop="companyUserNickName">
           <el-input  v-model="queryParams.companyUserNickName"  placeholder="请输入员工名称" clearable size="small" @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="订单号" prop="orderSn">
        <el-input v-model="queryParams.orderSn"  placeholder="请输入订单号" clearable size="small" @keyup.enter.native="handleQuery" />
      </el-form-item>

     <el-form-item label="病人名称" prop="patientName">
          <el-input v-model="queryParams.patientName"  placeholder="请输入病人名称" clearable size="small"  />
      </el-form-item>
           <el-form-item label="医生" prop="doctorName"><el-input v-model="queryParams.doctorName" placeholder="请输入医生名称" clearable size="small" @keyup.enter.native="handleQuery" />
      </el-form-item>

   <!--   <el-form-item label="发卷人" prop="sendName">
           <el-input  v-model="queryParams.sendName"  placeholder="请输入发卷人" clearable size="small" @keyup.enter.native="handleQuery"/>
      </el-form-item -->

      <el-form-item label="订单类型" prop="orderType">
         <el-select v-model="queryParams.orderType" placeholder="状态" clearable size="small">
            <el-option v-for="dict in inquiryOrderOptions" :key="dict.dictValue" :label="dict.dictLabel" :value="dict.dictValue" />
         </el-select>
      </el-form-item>
      <el-form-item label="子类型" prop="inquirySubType">
         <el-select v-model="queryParams.inquirySubType" placeholder="子类型" clearable size="small">
            <el-option v-for="dict in inquirySubTypeOptions" :key="dict.dictValue" :label="dict.dictLabel" :value="dict.dictValue" />
         </el-select>
      </el-form-item>
      <el-form-item label="会员电话" prop="phone">
           <el-input v-model="queryParams.phone" placeholder="请输入会员电话"  clearable  size="small" @keyup.enter.native="handleQuery"/>
       </el-form-item>



      <el-form-item label="咨询开始时间" prop="startTime">
         <el-date-picker v-model="startTime" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" @change="change"></el-date-picker>
      </el-form-item>

      <el-form-item label="创建时间" prop="createTimeRange">
        <el-date-picker style="width:205.4px" clearable size="small" v-model="createTimeRange"  type="daterange"  value-format="yyyy-MM-dd"  start-placeholder="开始日期" end-placeholder="结束日期"> </el-date-picker>
      </el-form-item>

      <el-form-item label="支付时间" prop="payTimeRange">
        <el-date-picker style="width:205.4px" clearable size="small" v-model="payTimeRange" type="daterange" value-format="yyyy-MM-dd"  start-placeholder="开始日期"  end-placeholder="结束日期"> </el-date-picker>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">

      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['his:inquiryOrder:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="small"
          :loading="exportLoading"
          @click="handleExportMessageFeedback"
          v-hasPermi="['his:inquiryOrder:messageFeedbackExport']"
        >咨询信息反馈单</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
 <el-tabs type="card" v-model="actName" @tab-click="handleClickX">
      <el-tab-pane label="全部订单" name="10"></el-tab-pane>
      <el-tab-pane v-for="(item,index) in inquiryStatusOptions" :label="item.dictLabel" :name="item.dictValue"></el-tab-pane>
    </el-tabs>
    <el-table height="500" v-loading="loading" border :data="inquiryOrderList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="订单号" align="center" prop="orderSn" width="200px"/>
      <el-table-column label="咨询标题" align="center" prop="title" show-overflow-tooltip />
      <el-table-column label="病人名称" align="center" prop="patientName" />
      <el-table-column label="医生名称" align="center" prop="doctorName" />
      <el-table-column label="员工" align="center" prop="companyUserName" />
      <el-table-column label="公司" align="center" prop="companyName" />
      <el-table-column label="状态" align="center" prop="status" >
        <template slot-scope="scope">
          <dict-tag :options="inquiryStatusOptions" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="订单类型" align="center" prop="orderType">
            <template slot-scope="scope">
              <dict-tag :options="inquiryOrderOptions" :value="scope.row.orderType"/>
            </template>
      </el-table-column>
      <el-table-column label="订单子类型" align="center" prop="inquirySubType" width="90px">
            <template slot-scope="scope">
              <dict-tag :options="inquirySubTypeOptions" :value="scope.row.inquirySubType"/>
            </template>
      </el-table-column>
      <el-table-column label="支付类型" align="center" prop="payType" width="90px">
        <template slot-scope="scope">
          <dict-tag :options="inquiryPayOptions" :value="scope.row.payType"/>
        </template>
      </el-table-column>
      <el-table-column label="是否支付" align="center" prop="isPay" >
        <template slot-scope="scope">
          <dict-tag :options="orOptions" :value="scope.row.isPay"/>
        </template>
      </el-table-column>
      <el-table-column label="订单金额" align="center" prop="money" />
      <el-table-column label="支付金额" align="center" prop="payMoney" />
      <el-table-column label="优惠金额" align="center" prop="discountMoney" />
      <el-table-column label="支付时间" align="center" prop="payTime" width="180"/>
      <el-table-column label="审核时间" align="center" prop="auditTime" width="180"/>
      <el-table-column label="导医" align="center" prop="userName" width="180"/>
      <el-table-column label="创建时间" align="center" prop="createTime" width="180" />
      <el-table-column label="咨询开始时间" align="center" prop="startTime" width="180" />
      <el-table-column label="结束时间" align="center" prop="finishTime" width="180" />
      <el-table-column label="是否评价" align="center" prop="isPing" >
        <template slot-scope="scope">
          <dict-tag :options="orOptions" :value="scope.row.isPing"/>
        </template>
      </el-table-column>
      <el-table-column label="评分" align="center" prop="pingStar" width="170px">
        <template slot-scope="scope" >
          <el-rate v-if="scope.row.pingStar!=null"
            v-model="scope.row.pingStar"
            disabled
            show-score
            text-color="#ff9900"
            score-template="{value}">
          </el-rate>
        </template>

      </el-table-column>
      <el-table-column label="科室名称" align="center" prop="deptName" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="100px">
        <template slot-scope="scope">
       <el-button
                  size="mini"
                  type="text"
                  @click="handledetails(scope.row)"
                   icon="el-icon-share"
                >详情
      </el-button>
      <el-link type="primary" @click="getMsg(scope.row)" :underline="false" >聊天记录</el-link>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

   <el-drawer
        :with-header="false"
        size="75%"
         :title="show.title" :visible.sync="show.open">
     <inquiryOrderDetails  ref="Details" />
   </el-drawer>
    <el-dialog title="聊天记录" :visible.sync="msgDialog.open" width="80%"  append-to-body >
      <msgDetails  ref="msgDetails" :msgDialogClose="msgDialogClose" />
      <span slot="footer" class="dialog-footer">
        <el-button @click="msgDialogClose">取 消</el-button>
        <el-button type="primary" @click="msgDialogClose">确 定</el-button>
      </span>
    </el-dialog>

  </div>
</template>

<script>
import { msglist,listinquiryOrder, getinquiryOrder, delinquiryOrder, addinquiryOrder, updateinquiryOrder, exportinquiryOrder,exportMessageFeedback } from "@/api/his/inquiryOrder";
import {allList}from "@/api/company/company";
import inquiryOrderDetails from '../../components/his/inquiryOrderDetails.vue';
import msgDetails from '../../components/his/msgDetails.vue';
import { getTask } from "@/api/common";
export default {
  name: "ofast",
  components: { inquiryOrderDetails,msgDetails },
  data() {
    return {
      msgForm:{
          pageNum: 1,
          pageSize: 10,
          orderId:null,
        },
      msg:[],
      msgDialog:{
        title:"",
        open:false
      },
      actName:"10",
      show:{
        title:"咨询详情",
        open:false,
      },
       startTime:null,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 咨询订单表格数据
      inquiryOrderList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      createTimeRange:[],
      payTimeRange:[],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        orderSn: null,
        title: null,
        imgs: null,
        userId: null,
        patientId: null,
        orderType: null,
        money: null,
        payMoney: null,
        payType: null,
        isPay: null,
        doctorId: null,
        payTime: null,
        status: null,
        startTime: null,
        sTime:null,
        eTime:null,
        finishTime: null,
        isPing: null,
        pingStar: null,
        pingContent: null,
        departmentId: null,
        inquiryType: 2,
        doctorName:null,
        patientName:null,
        sendName:null,
        phone:null,
        inquirySubType:null,
        companyUserName:null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      inquiryStatusOptions:[],
      inquiryTypeOptions:[],
      inquiryPayOptions:[],
      companyList:[],
      inquiryOrderOptions:[],
      inquirySubTypeOptions:[],
      orOptions:[],
    };
  },
  created() {
      this.getDicts("sys_inquiry_status").then(response => {
          this.inquiryStatusOptions = response.data;
        });
      this.getDicts("sys_inquiry_type").then(response => {
          this.inquiryTypeOptions = response.data;
        });
      this.getDicts("sys_inquiry_pay").then(response => {
          this.inquiryPayOptions = response.data;
        });
      this.getDicts("sys_inquiry_order_type").then(response => {
          this.inquiryOrderOptions = response.data;
        });
      this.getDicts("sys_company_or").then(response => {
          this.orOptions = response.data;
        });
      this.getDicts("sys_inquiry_sub_type").then(response => {
        this.inquirySubTypeOptions = response.data;
      });

    this.getList();
    this.getAllCompany();
  },
  methods: {
    getMsg(row){
      const orderId = row.orderId;
      const doctorName = row.doctorName;
      const patientName = row.patientName;
      this.msgForm.orderId=orderId;
        msglist(this.msgForm).then(response => {
          if (!response.rows || response.rows.length === 0) {
         this.$message({
              message: '此订单无消息记录',
              type: 'info'
            });
          return
        }else{
          this.msgDialog.open = true;
          setTimeout(() => {
            this.$refs.msgDetails.getDetails(orderId,doctorName,patientName);
          }, 500);
        }
      });
    },
    msgDialogClose(){
      this.msgDialog.open = false;
    },
  handleClickX(tab, event) {
   if(tab.name=="10"){
     this.queryParams.status=null;
   }else{
     this.queryParams.status=tab.name;
   }
    this.handleQuery();
  },
        handledetails(row){
            this.show.open=true;
            setTimeout(() => {
                 this.$refs.Details.getDetails(row.orderId);
            }, 1);
        },
    /** 查询咨询订单列表 */
    getList() {
      this.loading = true;
      if(this.createTimeRange!=null&&this.createTimeRange.length==2){
        this.queryParams.createTimeRange=this.createTimeRange[0]+"--"+this.createTimeRange[1]
      }
      else{
        this.queryParams.createTimeRange=null;
      }
      if(this.payTimeRange!=null&&this.payTimeRange.length==2){
        this.queryParams.payTimeRange=this.payTimeRange[0]+"--"+this.payTimeRange[1]
      }
      else{
        this.queryParams.payTimeRange=null;
      }
      listinquiryOrder(this.queryParams).then(response => {
        this.inquiryOrderList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getAllCompany() {
      allList().then(response => {
        this.companyList = response.rows;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        orderId: null,
        orderSn: null,
        title: null,
        imgs: null,
        userId: null,
        patientId: null,
        orderType: null,
        money: null,
        payMoney: null,
        payType: null,
        isPay: null,
        doctorId: null,
        createTime: null,
        payTime: null,
        status: null,
        startTime: null,
        finishTime: null,
        remark: null,
        isPing: null,
        pingStar: null,
        pingContent: null,
        departmentId: null,
        inquiryType: 2,
        doctorName:null,
        patientName:null,
        phone:null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    change(){
      if(this.startTime!=null){
        this.queryParams.sTime=this.startTime[0];
        this.queryParams.eTime=this.startTime[1];
      }else{
        this.queryParams.sTime=null;
        this.queryParams.eTime=null;
      }

    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTimeRange=null;
      this.payTimeRange=null;
      this.startTime=null;
      this.queryParams.sTime=null;
      this.queryParams.eTime=null;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.orderId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加咨询订单";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const orderId = row.orderId || this.ids
      getinquiryOrder(orderId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改咨询订单";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.orderId != null) {
            updateinquiryOrder(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addinquiryOrder(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const orderIds = row.orderId || this.ids;
      this.$confirm('是否确认删除咨询订单编号为"' + orderIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delinquiryOrder(orderIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
		var that=this;
      if(this.createTimeRange!=null&&this.createTimeRange.length==2){
        this.queryParams.createTimeRange=this.createTimeRange[0]+"--"+this.createTimeRange[1]
      }
      else{
        this.queryParams.createTimeRange=null;
      }
      if(this.payTimeRange!=null&&this.payTimeRange.length==2){
        this.queryParams.payTimeRange=this.payTimeRange[0]+"--"+this.payTimeRange[1]
      }
      else{
        this.queryParams.payTimeRange=null;
      }
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有咨询订单数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportinquiryOrder(queryParams);
        }).then(response => {
          if(response.code==200){
          that.msgSuccess(response.msg);
          that.taskId=response.data;
          that.time=setInterval(function(){
            //查订单
            getTask(that.taskId).then(res => {
              if(res.data.status==1){
                that.exportLoading = false;
                clearTimeout(that.time)
                that.time=null;
                that.download(res.data.fileUrl);
              }
            });
          },10000);
        }
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExportMessageFeedback() {
		var that=this;
      if(this.createTimeRange!=null&&this.createTimeRange.length==2){
        this.queryParams.createTimeRange=this.createTimeRange[0]+"--"+this.createTimeRange[1]
      }
      else{
        this.queryParams.createTimeRange=null;
      }
      if(this.payTimeRange!=null&&this.payTimeRange.length==2){
        this.queryParams.payTimeRange=this.payTimeRange[0]+"--"+this.payTimeRange[1]
      }
      else{
        this.queryParams.payTimeRange=null;
      }
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有咨询信息反馈单数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportMessageFeedback(queryParams);
        }).then(response => {
		   if(response.code==200){
		   that.msgSuccess(response.msg);
		   that.taskId=response.data;
		   that.time=setInterval(function(){
			 //查订单
			 getTask(that.taskId).then(res => {
			   if(res.data.status==1){
				 that.exportLoading = false;
				 clearTimeout(that.time)
				 that.time=null;
				 that.download(res.data.fileUrl);
			   }
			 });
		   },10000);
		 }
        }).catch(() => {});
    }
  }
};
</script>
